#!C:\Perl\bin\perl
use warnings;

###################################################################################
## Author: Venice Margarette B. Juanillas
## Date Created: May 10,2011
## Program Description: This script will read an alchemy-derived text output 
##						and transform it into the matrix form getting only
##						the ff:
##							Sample names
##							SNP ID
##							AB Calls
##						This matrix will further be utilized by other formats.
##
## Citation: This script was made based from Sir Mauleon's existing script.
###################################################################################

## declarations
my $line_count = 1;
my $line;
my $index;
my $hline = 1; ## flag if header line
my $prev;
my $firstSNP = 0; #marks the number of samples read
my $nt; ## for the new symbol to be used
my @row = (); ## declare all arrays null
my @string = ();
my @sample_id = ();
my @nullarray = ();

check();

sub check{
	## check for file parameters
	my $param_num = scalar(@ARGV);
	if(!@ARGV  or ($param_num < 2) or ($param_num > 3)){
		print "Enter input, output  files and column number respectively.\n";
	}elsif(!$ARGV[2]){
		$ARGV[2] = 3;
		main($ARGV[0],$ARGV[1],$ARGV[2]); ## default column parameter: 3
	}else{
		main($ARGV[0],$ARGV[1],$ARGV[2]); ## isama na ang col number para dynamic ang paggawa ng matrix
	}
}

sub main{
	my ($infile,$outfile,$col) = @_;
	
	$index = $col; ## column to be used made global 
	
	#open input and output files
	open(IN,"$infile") || die "Cannot open file.";
	open(OUT,">$outfile") || die "Cannot open file.";

	#read one line at a time
	while($line = <IN>){
		next if $line =~ /^\s*$/; # skip blank lines 
		if ($line_count <= 6){
			$line_count++;
			next;
		}
		@row = split(/\t/,$line);	#split every line delimited by tab or newline
		# if $line is already in the first data line
		if($hline == 1){
			push(@Sample_id, $row[1]); # create the stack of Sample id's
			push(@string,$row[0]); #create the stack of SNP id's
			pushGenotype(); # call to a subroutine
			$prev = $row[0];  #replace prev SNP name with current SNP name
			$hline = 0;  ## flag as not 1st data line anymore
			$firstSNP =1 ;
			next;
		}
		#if within the sample SNP
		if($row[0] eq $prev){
			push(@Sample_id,$row[1]);
			pushGenotype(); 
			next;
		}
		#if out of the prev SNP, go and read the next SNP
		if ($row[0] ne $prev) {  
			if ($hline != 1) { 
				if ($firstSNP == 1) {  ## ung 1st pass lang dapat
					print OUT "SNP_Sample_ids"; ## print to output file...

					foreach (@Sample_id) {
						print OUT "\t$_";
					} ##end for each
					print OUT "\n";
					$firstSNP = 0 ; 
				} 

				##print the genotype string..
				foreach (@string) {
					print OUT "$_\t";
				} ## end foreach
				print OUT "\n";
				@string = @nullarray;
			}
			
			push (@string, $row[0]);  #push SNP name as 1st array element
			$prev = $row[0];  #replace prev SNP name with current SNP name
			$firstSNP = 0 ; 
			pushGenotype();
			next;

		} ## end if currline <> prev	
		
	}

	## output lahat ng SNP names
	foreach (@string) {
		print OUT "$_\t";
	}
	print OUT "\n";

	#close all files
	close(IN);
	close(OUT);
}


## this subroutine will assign the AB calls sor every SNP and Sample id's
## based from Sir Mau's pushGenotype code
sub pushGenotype {

		$nt = $row[$index];  ##assign AB call column na pinipick-up
		
		## check for all possible genotypes
		if ($row[$index] eq "AA") {
			$nt = "A/A"; ## overwrite $nt by assigning a new notation
		}
		if ($row[$index] eq "BB") {
			$nt = "B/B";
		}
		if ($row[$index] eq "AB" || $row[$index] eq "BA")  {
			$nt = "A/B";
		}
		if ($row[$index] eq " ") {
			$nt = "-/-";
		}
		if ($row[$index] eq "TT") {
			$nt = "T/T";
		}
		if ($row[$index] eq "CC") {
			$nt = "C/C";
		}
		if ($row[$index] eq "TC" || $row[$index] eq "CT") {
			$nt = "T/C";
		}
		if ($row[$index] eq "GG") {
			$nt = "G/G";
		}
		if ($row[$index] eq "GC" || $row[$index] eq "CG") {
			$nt = "C/G";
		}
		if ($row[$index] eq "GA" || $row[$index] eq "AG") {
			$nt = "A/G";
		}
		if ($row[$index] eq "TA" || $row[$index] eq "AT") {
			$nt = "A/T";
		}
		push (@string, $nt);  ## push the new symbol to the array
		return;		

} 

## end of script





